Imports System.Data.OleDb
Imports System.IO
Public Class LocalLadder

#Region " Results Template "

    '   Team       Score   
    '5  GDI        13688   
    '2  Nod        4646    

    '     Player     Kills   Deaths  K/D     Credits Score   Ladder  Rank    
    '  1. havoc0911  10      3       3.3     3243    4244    10       -        GDI
    '  2. fmcgee10   6       5       1.2     687     1761    5        -        GDI
    '  3. contra82   18      2       9.0     302     1453    3        -        GDI
    '  4. DIVADSfat  6       4       1.5     91      637     1        -        GDI
    '  5. draco7x  ##4       9       0.4     671     2203    0        -        Nod
    '  5. Tragos420  19      1       19.0    841     591     0        -        GDI
    '  6. sk8erdie3##0       0       -       268     0       0        -        Nod
    '  6. gfr99      2       8       0.3     644     1058    -1       -        Nod
    '  7. bugspray1##1       14      0.1     113     511     -3       -        Nod
    '  7. c4s3n1   ##5       20      0.3     75      441     -5       -        Nod
    '  7. Cubbie16   3       7       0.4     31      431     -6       -        Nod

#End Region

#Region " Sample Usage "
    '*******************MS ACCESS DB
    'dim myDB as string = "C:\BRLad.mdb"
    'dim myDBType as BRLocalLadder.LocalLadder.DBType = DBTYPE.MS_ACCESS
    'dim myLadder as New BRLocalLadder.LocalLadder()
    'myLadder.DB_LOCATION = myDB
    'myLadder.DB_Type  = myDBType

    'update local ladder
    'if myLadder.ProcessLadder("C:\RenegadeFDS\Server\results01.txt") then
    '   msgbox("Ladder Processed")
    'else
    '   msgbox("could not process ladder")
    'end if

    'retrieve ladder
    'dim sPlayer as BRLocalLadder.LocalLadder.PlayerLadderInfo
    'sPlayer = myLadder.GetLadder("n00bplayer")
    'if not sPlayer is nothing then
    '   msgbox(sPlayer.PlayerName & " has recieved " & sPlayer.Ladder & " ladder points on this server.")
    'else
    '   msgbox("Player not found")
    'end if

    'clean up
    'set myLadder = nothing
    'set myDBType = nothing


    '******************MS SQL 7.0 DB 
    'dim myServer as string = "192.168.1.1"
    'dim myDB as string = "MyBlazeNet"
    'dim myDBPass as string = "mypass"
    'dim myDBUser as string = "myuser"
    'dim myDBType as BRLocalLadder.LocalLadder.DBType = DBTYPE.MS_SQL7
    'dim myLadder as New BRLocalLadder.LocalLadder()
    'myLadder.DB_Location = myServer
    'myLadder.DB_Database = myDB
    'myLadder.DB_UserID = myDBUser
    'myLadder.DB_Password = myDBPass
    'myLadder.DB_Type = myDBType

    '********************************************************update ladder
    'if myLadder.ProcessLadder("C:\RenegadeFDS\Server\results01.txt") then
    '   msgbox("Ladder Processed")
    'else
    '   msgbox("could not process ladder")
    'end if

    'retrieve ladder
    'dim sPlayer as BRLocalLadder.LocalLadder.PlayerLadderInfo
    'sPlayer = myLadder.GetLadder("n00bplayer")
    'if not sPlayer is nothing then
    '   msgbox(sPlayer.PlayerName & " has recieved " & sPlayer.Ladder & " ladder points on this server.")
    'else
    '   msgbox("Player not found")
    'end if

    'cleanup
    'set myLadder = nothing
    'set myDBType = nothing


    '******************MS SQL 2000 
    'dim myServer as string = "192.168.1.1\MyInstance"
    'dim myDB as string = "MyBlazeNet"
    'dim myDBPass as string = "mypass"
    'dim myDBUser as string = "myuser"
    'dim myDBType as BRLocalLadder.LocalLadder.DBType = DBTYPE.MS_SQL2K
    'dim myLadder as New BRLocalLadder.LocalLadder()
    'myLadder.DB_Location = myServer
    'myLadder.DB_Database = myDB
    'myLadder.DB_UserID = myDBUser
    'myLadder.DB_Password = myDBPass
    'myLadder.DB_Type = myDBType

    '*update ladder
    'if myLadder.ProcessLadder("C:\RenegadeFDS\Server\results01.txt") then
    '   msgbox("Ladder Processed")
    'else
    '   msgbox("could not process ladder")
    'end if

    'retrieve ladder
    'dim sPlayer as BRLocalLadder.LocalLadder.PlayerLadderInfo
    'sPlayer = myLadder.GetLadder("n00bplayer")
    'if not sPlayer is nothing then
    '   msgbox(sPlayer.PlayerName & " has recieved " & sPlayer.Ladder & " ladder points on this server.")
    'else
    '   msgbox("Player not found")
    'end if

    'clean up
    'set myLadder = nothing
    'set myDBType = nothing


    '******************MY SQL DB 
    'dim myServer as string = "192.168.1.1"
    'dim myDB as string = "MyBlazeNet"
    'dim myDBPass as string = "mypass"
    'dim myDBUser as string = "myuser"
    'dim myDBType as BRLocalLadder.LocalLadder.DBType = DBTYPE.MY_SQL
    'dim myLadder as New BRLocalLadder.LocalLadder()
    'myLadder.DB_Location = myServer
    'myLadder.DB_Database = myDB
    'myLadder.DB_UserID = myDBUser
    'myLadder.DB_Password = myDBPass
    'myLadder.DB_Type = myDBType

    'update ladder
    'if myLadder.ProcessLadder("C:\RenegadeFDS\Server\results01.txt") then
    '   msgbox("Ladder Processed")
    'else
    '   msgbox("could not process ladder")
    'end if

    'retrieve ladder
    'dim sPlayer as BRLocalLadder.LocalLadder.PlayerLadderInfo
    'sPlayer = myLadder.GetLadder("n00bplayer")
    'if not sPlayer is nothing then
    '   msgbox(sPlayer.PlayerName & " has recieved " & sPlayer.Ladder & " ladder points on this server.")
    'else
    '   msgbox("Player not found")
    'end if

    'clean up
    'set myLadder = nothing
    'set myDBType = nothing


#End Region

#Region " Declares and variables "

    Private s_dblocal As String = "c:\BRLad.mdb"
    Private s_dbtype As DBType
    Private s_dbpass As String = ""
    Private s_dbuser As String = ""
    Private s_dbdb As String = ""
    Private s_dbconnstring As String
    Private s_dbtable As String = ""
    Public AppPath As String = ""

    Public Enum DBType
        MS_ACCESS = 0
        MS_SQL7 = 1
        MS_SQL2K = 2
        MY_SQL = 3
    End Enum

    Public Property DB_Password() As String
        Get
            Return s_dbpass
        End Get
        Set(ByVal Value As String)
            s_dbpass = Value
        End Set
    End Property

    Public Property DB_UserID() As String
        Get
            Return s_dbuser
        End Get
        Set(ByVal Value As String)
            s_dbuser = Value
        End Set
    End Property

    Public Property DB_DataBase() As String
        Get
            Return s_dbdb
        End Get
        Set(ByVal Value As String)
            s_dbdb = Value
        End Set
    End Property

    Public Property DB_LOCATION() As String
        Get
            Return s_dblocal
        End Get
        Set(ByVal Value As String)
            s_dblocal = Value
        End Set
    End Property

    Public Property DB_Table() As String
        Get
            Return s_dbtable
        End Get
        Set(ByVal Value As String)
            s_dbtable = Value
        End Set
    End Property

    Public Property DB_Type() As DBType
        Get
            Return s_dbtype
        End Get
        Set(ByVal Value As DBType)
            s_dbtype = Value
            s_dbconnstring = SetConnectionString(s_dbtype)
        End Set
    End Property

    Public Structure PlayerLadderInfo
        Dim PlayerName As String
        Dim Kill As Integer
        Dim Deaths As Integer
        Dim Ratio As Double
        Dim Score As Long
        Dim Ladder As String
        Dim Rank As String
        Dim Nod As Integer
        Dim GDI As Integer
    End Structure

#End Region

#Region " Exports "
    Public Function ProcessLadder(ByVal FileName As String) As Boolean
        Dim tmp() As String, ff As Integer = FreeFile(), i As Integer = 0, pLad As PlayerLadderInfo
        If Dir(FileName) <> "" Then
            Try
                FileOpen(ff, FileName, OpenMode.Input)
                Do Until EOF(ff) = True
                    ReDim Preserve tmp(i)
                    tmp(i) = LineInput(ff)
                    i = i + 1
                Loop
                FileClose(ff)
                File.Copy(FileName, GetNextResults())
                File.Delete(FileName)
                If UBound(tmp) < 6 Then Return False : Exit Function 'no players
                For i = 5 To UBound(tmp) - 1
                    Dim ptmp1() As String, ii As Integer, iii As Integer = 0, ptmp2(10) As String
                    If InStr(tmp(i), "Loading") Then GoTo EndOfNext
                    tmp(i) = Replace(tmp(i), " - ", " 0 ")
                    tmp(i) = Replace(tmp(i), "#", " ")
                    ptmp1 = Split(tmp(i), " ")
                    For ii = 0 To UBound(ptmp1)
                        If ptmp1(ii) <> "" Then
                            ptmp2(iii) = ptmp1(ii) : iii = iii + 1
                        End If
                    Next
                    pLad.PlayerName = ptmp2(1)
                    pLad.Kill = ptmp2(2)
                    pLad.Deaths = ptmp2(3)
                    pLad.Ratio = ptmp2(4)
                    pLad.Score = ptmp2(6)
                    pLad.Ladder = ptmp2(7)
                    pLad.Rank = 0
                    If ptmp2(9) = "GDI" Then
                        pLad.GDI = 1
                    Else
                        pLad.Nod = 1
                    End If
                    UpdateDB(pLad)
                    pLad = Nothing
EndOfNext:
                Next
            Catch e As Exception
                'MsgBox(e.ToString)
                Return False
                Exit Function
            Finally
                FileClose(ff)
            End Try
            Return True
        Else
            'error, file NOT there... something fishy
            Return False
        End If
    End Function

    Public Function GetLadder(ByVal LadderID As Integer) As PlayerLadderInfo
        Dim tmpPlayer As PlayerLadderInfo
        tmpPlayer.Rank = LadderID
        Dim strSQL As String = "Select * from " & s_dbtable & " ORDER BY pLadder DESC, pScore DESC"
        Dim strConn As String = s_dbconnstring
        Dim SQL As Data.OleDb.OleDbConnection
        Dim DBC As Data.OleDb.OleDbCommand
        Dim DR As Data.OleDb.OleDbDataReader
        Dim tmp As String
        Dim i As Integer
        Try
            SQL = New Data.OleDb.OleDbConnection(strConn)
            DBC = New Data.OleDb.OleDbCommand(strSQL, SQL)
            SQL.Open()
            DR = DBC.ExecuteReader()
            Do Until DR.Read() = False
                i = i + 1
                If i = LadderID Then
                    tmpPlayer.PlayerName = DR("pName")
                    tmpPlayer.Kill = DR("pKills")
                    tmpPlayer.Deaths = DR("pDeaths")
                    tmpPlayer.Score = DR("pScore")
                    tmpPlayer.GDI = DR("pGDI")
                    tmpPlayer.Nod = DR("pNod")
                    tmpPlayer.Ladder = DR("pLadder")
                    If IsNumeric(Format(DR("pKills") / DR("pDeaths"), "#.##")) <> True Then
                        tmpPlayer.Ratio = 0
                    Else
                        tmpPlayer.Ratio = Format(DR("pKills") / DR("pDeaths"), "#.##")
                    End If
                    tmpPlayer.Rank = i
                End If
            Loop
            DR.Close()
            DR = Nothing
        Catch e As Exception
            'MsgBox(e.Message.ToString)
            tmpPlayer.PlayerName = ""
        Finally
            If Not DBC Is Nothing Then DBC = Nothing
            If Not SQL Is Nothing Then SQL.Close()
            SQL = Nothing
        End Try
        Return tmpPlayer

    End Function

    Public Function GetLadder(ByVal PlayerName As String) As PlayerLadderInfo
        Dim tmpPlayer As PlayerLadderInfo
        tmpPlayer.PlayerName = PlayerName
        If PlayerExist(PlayerName) = False Then
            Return Nothing
        Else
            Dim strSQL As String = "Select * from " & s_dbtable & " ORDER BY pLadder DESC, pScore DESC"
            Dim strConn As String = s_dbconnstring
            Dim SQL As Data.OleDb.OleDbConnection
            Dim DBC As Data.OleDb.OleDbCommand
            Dim DR As Data.OleDb.OleDbDataReader
            Dim tmp As String
            Dim i As Integer
            Try
                SQL = New Data.OleDb.OleDbConnection(strConn)
                DBC = New Data.OleDb.OleDbCommand(strSQL, SQL)
                SQL.Open()
                DR = DBC.ExecuteReader()
                Do Until DR.Read() = False
                    i = i + 1
                    If DR("pName") = PlayerName Then
                        tmpPlayer.Kill = DR("pKills")
                        tmpPlayer.Deaths = DR("pDeaths")
                        tmpPlayer.Score = DR("pScore")
                        tmpPlayer.GDI = DR("pGDI")
                        tmpPlayer.Nod = DR("pNod")
                        tmpPlayer.Ladder = DR("pLadder")
                        If IsNumeric(Format(DR("pKills") / DR("pDeaths"), "#.##")) <> True Then
                            tmpPlayer.Ratio = 0
                        Else
                            tmpPlayer.Ratio = Format(DR("pKills") / DR("pDeaths"), "#.##")
                        End If
                        tmpPlayer.Rank = i
                    End If
                Loop
                DR.Close()
                DR = Nothing
            Catch e As Exception
                'MsgBox(e.Message.ToString)
                tmpPlayer.PlayerName = ""
            Finally
                If Not DBC Is Nothing Then DBC = Nothing
                If Not SQL Is Nothing Then SQL.Close()
                SQL = Nothing
            End Try
            Return tmpPlayer
        End If
    End Function

    Public Function GetPlayers() As String()
        Dim strSQL As String = "Select pName from " & s_dbtable & " ORDER BY pLadder DESC, pScore DESC"
        Dim strConn As String = s_dbconnstring
        Dim SQL As Data.OleDb.OleDbConnection
        Dim DBC As Data.OleDb.OleDbCommand
        Dim DR As Data.OleDb.OleDbDataReader
        Dim tmp As String
        Dim i As Integer = 0
        Dim tPlayers() As String
        Try
            SQL = New Data.OleDb.OleDbConnection(strConn)
            DBC = New Data.OleDb.OleDbCommand(strSQL, SQL)
            SQL.Open()
            DR = DBC.ExecuteReader()
            Do Until DR.Read() = False
                ReDim Preserve tPlayers(i)
                tPlayers(i) = DR("pName")
                i = i + 1
            Loop
            DR.Close()
            DR = Nothing
        Catch e As Exception
            'MsgBox(e.Message.ToString)
        Finally
            If Not DBC Is Nothing Then DBC = Nothing
            If Not SQL Is Nothing Then SQL.Close()
            SQL = Nothing
        End Try
        Return tPlayers
    End Function

#End Region

#Region " Internal Functions "

    Private Function PlayerExist(ByVal pName As String) As Boolean
        Dim strSQL As String = "Select pName from " & s_dbtable & " WHERE pName = '" & pName & "'"
        Dim strConn As String = s_dbconnstring
        Dim SQL As Data.OleDb.OleDbConnection
        Dim DBC As Data.OleDb.OleDbCommand
        Dim DR As Data.OleDb.OleDbDataReader
        Dim tmp As String
        Try
            SQL = New Data.OleDb.OleDbConnection(strConn)
            DBC = New Data.OleDb.OleDbCommand(strSQL, SQL)
            SQL.Open()
            DR = DBC.ExecuteReader()
            If DR.Read() = False Then
                Return False
            Else
                Return True
            End If
            DR.Close()
            DR = Nothing
        Catch e As Exception
            'MsgBox(e.Message.ToString)
        Finally
            If Not DBC Is Nothing Then DBC = Nothing
            If Not SQL Is Nothing Then SQL.Close()
            SQL = Nothing
        End Try
    End Function

    Private Function UpdateDB(ByVal PI As PlayerLadderInfo) As Boolean
        Dim strConn As String = s_dbconnstring
        Dim SQL As Data.OleDb.OleDbConnection
        Dim DBC As Data.OleDb.OleDbCommand
        Try
            SQL = New Data.OleDb.OleDbConnection(strConn)
            Dim sqlString As String
            If PlayerExist(PI.PlayerName) Then
                sqlString = "Update " & s_dbtable & " Set pKills = pKills + " & PI.Kill & ", pDeaths = pDeaths + " & PI.Deaths & ", "
                If InStr(PI.Score, "-") Then
                    sqlString = sqlString & "pScore = pScore " & PI.Score & ", "
                Else
                    sqlString = sqlString & "pScore = pScore + " & PI.Score & ", "
                End If
                If InStr(PI.Ladder, "-") Then
                    sqlString = sqlString & "pLadder = pLadder " & PI.Ladder & ", "
                Else
                    sqlString = sqlString & "pLadder = pLadder + " & PI.Ladder & ", "
                End If
                If PI.GDI = 1 Then sqlString = sqlString & " pGDI = pGDI + 1 Where pName = '" & PI.PlayerName & "'"
                If PI.Nod = 1 Then sqlString = sqlString & " pNod = pNod + 1 Where pName = '" & PI.PlayerName & "'"
            Else
                sqlString = "Insert INTO " & s_dbtable & " (pName,pKills,pDeaths,pScore,pLadder,pGDI,pNod) Values('" & PI.PlayerName & "'," & PI.Kill & "," & PI.Deaths & "," & PI.Score & "," & PI.Ladder & "," & PI.GDI & "," & PI.Nod & ")" 'insert query
            End If
            DBC = New Data.OleDb.OleDbCommand(sqlString, SQL)
            SQL.Open()
            DBC.ExecuteNonQuery()
        Catch e As Exception
            'send some error here
            'MsgBox(e.Message.ToString)
        Finally
            If Not SQL Is Nothing Then : SQL.Close() : End If
            DBC = Nothing
            SQL = Nothing
        End Try

    End Function

    Private Function SetConnectionString(ByVal db As DBType) As String
        If s_dblocal <> "" Then
            Select Case s_dbtype
                Case DBType.MS_ACCESS
                    'simple access database
                    Return "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & s_dblocal
                Case DBType.MS_SQL7
                    Return "Provider=sqloledb;Server=" & s_dblocal & ";Database=" & s_dbdb & ";User Id=" & s_dbuser & ";Password=" & s_dbpass
                Case DBType.MS_SQL2K
                    Return "Provider=sqloledb;Server=" & s_dblocal & ";Database=" & s_dbdb & ";User Id=" & s_dbuser & ";Password=" & s_dbpass
                Case DBType.MY_SQL
                    Return "Provider=MySQLProv;Location=" & s_dblocal & ";Data Source=" & s_dbdb & ";User Id=" & s_dbuser & ";Password=" & s_dbpass
                Case Else
                    'unrecognized... do an error somehow
                    Return ""
            End Select
        Else
            'throw error
            Return ""
        End If
    End Function

    Private Function GetNextResults() As String
        Dim tmp As String, i As Integer, list() As String
        tmp = Dir(AppPath & "\Results\results*")
        Do Until tmp = ""
            i = i + 1
            tmp = Dir()
        Loop
        Return AppPath & "\Results\results" & CStr(i) & ".txt"
    End Function

#End Region

End Class
