Public Class PlayerWarning
    Dim pwarn As New Hashtable()

    Public Sub AddWarning(ByVal nick As String)
        If pwarn.ContainsKey(nick) <> True Then
            pwarn.Add(nick, 0)
        End If
        pwarn(nick) = pwarn(nick) + 1
    End Sub

    Public Sub AddPlayer(ByVal nick As String)
        pwarn.Add(nick, 1)
    End Sub

    Public Function GetWarning(ByVal nick As String) As Integer
        If Not pwarn(nick) Is Nothing Then
            Return pwarn(nick)
        Else
            Return 0
        End If
    End Function

    Public Sub ClearWarning(ByVal nick As String)
        pwarn.Remove(nick)
    End Sub

    Public Sub ClearAll()
        pwarn.Clear()
    End Sub

    Public Function SaveWarnings() As Boolean
        'save function here
        Try
            Dim fname As String = Application.StartupPath & "\warnings.brc", key As IDictionaryEnumerator = pwarn.GetEnumerator
            FileOpen(1, fname, OpenMode.Output)
            While key.MoveNext()
                Write(1, key.Key, key.Value)
            End While
            FileClose(1)
        Catch e As Exception
            Console.WriteLine(e.Message.ToString)
        End Try
        Return True
    End Function

    Public Sub LoadWarnings()
        'load function here
        Try
            Dim fname As String = Application.StartupPath & "\warnings.brc"
            Dim tmp1 As String, tmp2 As Integer
            If Dir(fname) <> "" Then
                FileOpen(1, fname, OpenMode.Input)
                pwarn.Clear()
                While EOF(1) = False
                    Input(1, tmp1)
                    Input(1, tmp2)
                    pwarn.Add(tmp1, tmp2)
                End While
                FileClose(1)
            End If
        Catch e As Exception
            Console.WriteLine(e.Message.ToString)
        Finally
        End Try
    End Sub

End Class
