Imports System.Text

Public Class RenChat4
    Private WithEvents cIRC As New IRCSocket()
    Private sNick As String
    Private sPass As String = "supersecret"
    Private sServer As String = "renchat4.westwood.com"
    Private iUSAPort As Integer = 7000
    Private iEUROPort As Integer = 7001
    Private iPACPort As Integer = 7002
    Private sSearch As String

    Public Property Nick() As String
        Get
            Nick = sNick
        End Get
        Set(ByVal Value As String)
            sNick = Value
        End Set
    End Property

    Public Event LocateReturn(ByVal retMessage As String)

    Public Sub LocatePlayerUSA(ByVal pName As String)
        sSearch = pName
        If pName.Substring(0, 1) = Chr(3) Or pName.Substring(0, 1) = Chr(31) Or pName.Substring(0, 1) = Chr(2) Then
            RaiseEvent LocateReturn("Please send the locate request without any formatting please...")
            Exit Sub
        End If
        cIRC.RemoteHost = sServer
        cIRC.RemotePort = iUSAPort
        cIRC.Connect()
    End Sub
    Public Sub LocatePlayerEURO(ByVal pName As String)
        sSearch = pName
        If pName.Substring(0, 1) = Chr(3) Then
            RaiseEvent LocateReturn("Please send the locate request without any formatting please...")
            Exit Sub
        End If
        cIRC.RemoteHost = sServer
        cIRC.RemotePort = iEUROPort
        cIRC.Connect()
    End Sub
    Public Sub LocatePlayerPAC(ByVal pName As String)
        sSearch = pName
        If pName.Substring(0, 1) = Chr(3) Then
            RaiseEvent LocateReturn("Please send the locate request without any formatting please...")
            Exit Sub
        End If
        cIRC.RemoteHost = sServer
        cIRC.RemotePort = iPACPort
        cIRC.Connect()
    End Sub

    Private Sub cIRC_Connected() Handles cIRC.Connected
        cIRC.SendString("NICK " & sNick & vbCrLf)
        cIRC.SendString("PASS " & sPass & vbCrLf)
        cIRC.SendString("FINDUSEREX " & sSearch & " 0 " & vbCrLf)
    End Sub

    Private Sub cIRC_DataArrival(ByVal sData As String) Handles cIRC.DataArrival
        Dim inData As String = sData
        Dim lData() As String = Nothing
        Dim C() As String = Nothing
        Dim tData As Integer = 0
        Dim CL As Integer = 0
        Dim CLi As String = Nothing
        Dim a As Integer = 0
        Dim i As Integer = FreeFile()

        lData = Split(inData, Chr(10))
        tData = UBound(lData) - LBound(lData)
        For a = 0 To tData
            If Mid(lData(a), 1, 1) = ":" Then
                lData(a) = Mid(lData(a), 2)
            End If
        Next
        'irc.westwood.com 398 Locator 0 :#crimson79,12,160  'playing on server
        'irc.westwood.com 398 Locator 1 :                   'not online
        'irc.westwood.com 398 Locator 2 :                   'locator off
        'irc.westwood.com 398 Locator 3 :                   'browsing servers
        'irc.westwood.com 398 Locator 0 :#Lob_12_0,0,416    'in chat room
        For CL = 0 To tData
            C = Split(lData(CL), " ")
            ReDim Preserve C(2000)
            CLi = lData(CL)
            If C(0) <> "" Then
                Select Case C(3)
                    Case "0" ' playing on server, or in chat room
                        Dim svrName As String
                        svrName = C(4).Substring(2, InStr(C(4), ",") - 3)
                        If svrName.ToLower = sSearch.ToLower Then
                            RaiseEvent LocateReturn("You have tried to locate the server " & svrName)
                        Else
                            RaiseEvent LocateReturn(sSearch & " is playing on server " & svrName)
                        End If
                    Case "1" 'not online
                        RaiseEvent LocateReturn(sSearch & " is not currently logged onto WOL")
                    Case "2" 'online, but locator is turned off
                        RaiseEvent LocateReturn(sSearch & " is logged onto WOL, but seems to have turned off there locator")
                    Case "3" 'browsing the servers listing
                        RaiseEvent LocateReturn(sSearch & " is logged onto WOL, but is still browsing for a game")
                End Select
            End If
        Next
        cIRC.Disconnect()
    End Sub
End Class
