Public Class BRStats
    Private myTimer As Threading.Timer
    Private pc As PerformanceCounter
    Public Sub New(ByRef pcBR As PerformanceCounter)
        pc = pcBR
        StartTimer(1000)
    End Sub
    Public Event Tick(ByVal value As String)

    Private Sub OnTimer(ByVal State As Object)
        Try
            RaiseEvent Tick(Format((CInt(pc.NextValue.ToString) / 1024), "#,###") & "k")
        Catch e As Exception

        End Try
    End Sub

    Private Sub StartTimer(ByVal period As Integer)
        ' Don't try to start a NULL timer.
        If IsNothing(myTimer) Then
            ' Create a callback to subroutine OnTimer
            Dim callback As New Threading.TimerCallback(AddressOf OnTimer)
            ' And start the timer, passing frequency specified in period.  Note: 
            ' Threading.Timer should not be confused with Timers.Timer.
            myTimer = New Threading.Timer(callback, Nothing, 0, period)
        End If
    End Sub

End Class
