Imports System.Text

Public Class RenChat2
    Private WithEvents cIRC As New IRCSocket()
    Private sNick As String
    Private sPass As String = "supersecret"
    Private sServer As String = "renchat2.westwood.com"
    Private iPort As Integer = 3845
    Private sSearch As String

    Public Property Nick() As String
        Get
            Nick = sNick
        End Get
        Set(ByVal Value As String)
            sNick = Value
        End Set
    End Property

    Public Event WOLStatsReturn(ByVal Stats As String, ByVal RawStats As String) 'do a split(rawstats,":") to read
    Public Event WOLNickNotFound(ByVal Nick As String)


    Public Sub WOLStats(ByVal pName As String)
        cIRC.RemoteHost = sServer
        cIRC.RemotePort = iPort
        sNick = pName
        cIRC.Connect()
    End Sub

    Private Sub cIRC_Connected() Handles cIRC.Connected
        cIRC.SendString("LISTSEARCH 16780288 -1 0 0 0 :" & sNick & ":" & Chr(10) & Chr(10))
    End Sub

    Private Sub cIRC_DataArrival(ByVal sData As String) Handles cIRC.DataArrival
        Dim inData As String = sData
        Dim lData() As String = Nothing
        Dim C() As String = Nothing
        Dim tData As Integer = 0
        Dim CL As Integer = 0
        Dim CLi As String = Nothing
        Dim a As Integer = 0
        Dim i As Integer = FreeFile()

        lData = Split(inData, Chr(10))
        tData = UBound(lData) - LBound(lData)
        For a = 0 To tData
            If Mid(lData(a), 1, 1) = ":" Then
                lData(a) = Mid(lData(a), 2)
            End If
        Next
        'TIMESTAMP(1043098303)
        'TOTAL(27466)
        'NOTFOUND()
        '26462  blazer0x  9228  46  63  0  376  496  883
        '25098  dante54an  9611  21  26  0  139  244  213
        Dim sTotal As String
        For CL = 0 To tData
            C = Split(lData(CL), " ")
            ReDim Preserve C(2000)
            CLi = lData(CL)
            If C(0) <> "" Then
                Select Case (C(0))
                    Case "TIMESTAMP"
                        'nothing
                    Case "TOTAL"
                        'save total
                        sTotal = C(1)
                    Case "NOTFOUND"
                        RaiseEvent WOLNickNotFound(sNick)
                    Case Else
                        'results found
                        Dim tmp1 As String, tmp2 As String
                        '<Rank> <NickName> <Points> <Wins> <Losses> <Unknown> <Kills> <Deaths> <TotalLosses>
                        tmp1 = (C(0) & ":" & C(2) & ":" & C(4) & ":" & C(6) & ":" & C(8) & ":" & C(10) & ":" & C(12) & ":" & C(14) & ":" & C(16))
                        tmp2 = C(2) & " is ranked " & C(0) & "/" & sTotal & " has " & C(4) & " points, with " & C(6) & " wins: " & C(8) & " losses: " & C(12) & " kills: " & C(14) & " deaths"
                        RaiseEvent WOLStatsReturn(tmp2, tmp1)
                End Select
            End If
        Next
        cIRC.Disconnect()
    End Sub

End Class
